#include "header\gba.h"
#include "header\bg.h"
#include "header\timer.h"
#include "header\dma.h"
#include "header\irq.h"
#include "header\sound.h"
#include "header\sprite.h"
#include "header\blend.h"

#include "header\font\BGFont.h"
//#include "header\font\BitMapFont.h"

#include "main.h"
#include "lib.h"
#include "syscall.h"
#include "resource.h"

#include <stdlib.h>

//Mode0
//BG0 

//---------------------------------------------------------------------------
#define STATE_INIT 					1		//is
#define STATE_LOAD					2
#define STATE_CONVERT				3
#define STATE_RUN					4
#define STATE_ERROR					5
#define STATE_END					6

#define SCREEN_TEXT_CX				30
#define SCREEN_TEXT_CY				20
#define SCREEN_TEXT_WCX				32
#define SCREEN_TEXT_WCY				32

#define WONBE_RESERVE_WORD_SIZE		16		//\̃TCY
#define WONBE_VARIABLE_SIZE			26		//ϐ̈̃TCY
#define WONBE_READ_LINE_SIZE		256		//\[X̍sǂݍތ
#define WONBE_WORK_SIZE				10000	//vÖ̃TCY
#define WONBE_FILE_START_OFFSET		0		//\[Xt@C̃ItZbgiSRAM̈j
#define WONBE_TABSTOP				4
#define WONBE_STACK_MAX				8
#define WONBE_STACK_TYPE_GOSUB		1
#define WONBE_STACK_TYPE_FOR		2

#define EOL							0x0d
#define CR							0x0d
#define LF							0x0a

//---------------------------------------------------------------------------
typedef struct {
	s8  x;									//J[\ʒu
	s8  y;
	s16 wy;
	u8 BGvofs;
} ST_SCREEN_TEXT;

typedef struct {
	u8   Type;								//Define`  1==GOSUB, 2==FOR
	u8*  ReturnPointer;
	//for GOSUB
	s16* LastLocalVal;
	s16  SimpleVal[WONBE_VARIABLE_SIZE];
	//for FOR
	s16* Pvar;								//JEgl
	s16  Limit;								//JEgl
	s16  Step;								//JEgZl
} ST_STACK;

typedef struct {
	u8*  FileOffset;						//t@C̊Jnʒu
	u8*  FileReadOffset;					//t@Cǂݍ݂̍Ɨp
	u16  ReadLineCnt;						//ǂݍ񂾍s̃JEg
	u8   ReadLine   [WONBE_READ_LINE_SIZE];	//Ps̓ǂݍ݃obt@
	u8   ConvertLine[WONBE_READ_LINE_SIZE];	//Ps̒Ԍobt@
	u8   Code       [WONBE_WORK_SIZE];		//sR[hobt@
	u16  CodeTop;							//sR[h̏I[l
	u16  DataTop;							//f[^̏I[l
	s16  GlobalVal  [WONBE_VARIABLE_SIZE];	//O[oϐ
	s16  TopLevelVal[WONBE_VARIABLE_SIZE];	//ŏw̃[Jϐ
	s16  Register[KEYWORD_ES-KEYWORD_AX+1];	//GBAł͖gp
	s16  Defseg;							//GBAł͖gp
	s16* LocalVal;							//XR[vŗLȃ[Jϐ̈
	u8*  ExecPointer;						//vOsEIP

	ST_STACK  Stack [WONBE_STACK_MAX];		//X^bN
	u16       StackCnt;						//X^bNJEg
} ST_WONBE;


typedef struct {
	u8  id;
	u8  name[WONBE_RESERVE_WORD_SIZE];
} ST_KEYWORDITEM;

//---------------------------------------------------------------------------
//\ꃊXg
ST_KEYWORDITEM KeyWordsA[] = {
	{ KEYWORD_AND, "and" },
	{ KEYWORD_ABS, "abs" },
	{ KEYWORD_AX , "ax"  },
	{ 0          , ""    }
};

ST_KEYWORDITEM KeyWordsB[] = {
	{ KEYWORD_BREAK, "break" },
	{ KEYWORD_BX   , "bx"    },
	{ 0            , ""      }
};

ST_KEYWORDITEM KeyWordsC[] = {
	{ KEYWORD_CHR      , "chr"       },
	{ KEYWORD_CLS      , "cls"       },
	{ KEYWORD_CONT     , "cont"      },
	{ KEYWORD_CALL     , "call"      },
	{ KEYWORD_CSEG     , "cseg"      },
	{ KEYWORD_CX       , "cx"        },
	{ KEYWORD_COLORMODE, "colormode" },
	{ KEYWORD_COLOR    , "color"     },
	{ 0                , ""          }
};

ST_KEYWORDITEM KeyWordsD[] = {
	{ KEYWORD_DEBUG , "debug"  },
	{ KEYWORD_DSEG  , "dseg"   },
	{ KEYWORD_DX    , "dx"     },
	{ KEYWORD_DI    , "di"     },
	{ KEYWORD_DS    , "ds"     },
	{ KEYWORD_DEFSEG, "defseg" },
	{ 0             , ""       }
};

ST_KEYWORDITEM KeyWordsE[] = {
	{ KEYWORD_END , "end"  },
	{ KEYWORD_EXIT, "exit" },
	{ KEYWORD_ES  , "es"   },
	{ 0           , ""     }
};

ST_KEYWORDITEM KeyWordsF[] = {
	{ KEYWORD_FOR  , "for"   },
	{ KEYWORD_FILES, "files" },
	{ 0            , ""      }
};

ST_KEYWORDITEM KeyWordsG[] = {
	{ KEYWORD_GOTO , "goto"  },
	{ KEYWORD_GOSUB, "gosub" },
	{ 0            , ""      }
};

ST_KEYWORDITEM KeyWordsH[] = {
	{ KEYWORD_HARDARCH, "hardarch" },
	{ 0               , ""         }
};

ST_KEYWORDITEM KeyWordsI[] = {
	{ KEYWORD_IF , "if"  },
	{ KEYWORD_INT, "int" },
	{ 0          , ""    }
};

ST_KEYWORDITEM KeyWordsL[] = {
	{ KEYWORD_LOCATE, "locate" },
	{ KEYWORD_LIST  , "list"   },
	{ KEYWORD_LOAD  , "load"   },
	{ 0             , ""       }
};

ST_KEYWORDITEM KeyWordsM[] = {
	{ KEYWORD_MERGE, "merge" },
	{ 0            , ""      }
};
ST_KEYWORDITEM KeyWordsN[] = {
	{ KEYWORD_NEXT, "next" },
	{ KEYWORD_NOT , "not"  },
	{ KEYWORD_NEW , "new"  },
	{ 0           , ""     }
};

ST_KEYWORDITEM KeyWordsO[] = {
	{ KEYWORD_OR, "or" },
	{ 0         , ""   }
};

ST_KEYWORDITEM KeyWordsP[] = {
	{ KEYWORD_PRINT  , "print"   },
	{ KEYWORD_PLAY   , "play"    },
	{ KEYWORD_PEEK   , "peek"    },
	{ KEYWORD_POKE   , "poke"    },
	{ KEYWORD_PALETTE, "palette" },
	{ 0              , ""        }
};

ST_KEYWORDITEM KeyWordsR[] = {
	{ KEYWORD_REM      , "rem"       },
	{ KEYWORD_RETURN   , "return"    },
	{ KEYWORD_RND      , "rnd"       },
	{ KEYWORD_RUN      , "run"       },
	{ KEYWORD_RANDOMIZE, "randomize" },
	{ 0                , ""          }
};

ST_KEYWORDITEM KeyWordsS[] = {
	{ KEYWORD_STEP   , "step"    },
	{ KEYWORD_SCAN_A , "scan_a"  },
	{ KEYWORD_SCAN_B , "scan_b"  },
	{ KEYWORD_SCAN_X1, "scan_x1" },
	{ KEYWORD_SCAN_X2, "scan_x2" },
	{ KEYWORD_SCAN_X3, "scan_x3" },
	{ KEYWORD_SCAN_X4, "scan_x4" },
	{ KEYWORD_SCAN_Y1, "scan_y1" },
	{ KEYWORD_SCAN_Y2, "scan_y2" },
	{ KEYWORD_SCAN_Y3, "scan_y3" },
	{ KEYWORD_SCAN_Y4, "scan_y4" },
	{ KEYWORD_SCAN   , "scan"    },	// scanscna_XɂȂ΂ȂȂ
	{ KEYWORD_SAVE   , "save"    },
	{ KEYWORD_SSEG   , "sseg"    },
	{ KEYWORD_SI     , "si"      },
	{ 0              , ""        }
};

ST_KEYWORDITEM KeyWordsT[] = {
	{ KEYWORD_THEN , "then"  },
	{ KEYWORD_TO   , "to"    },
	{ KEYWORD_TICK , "tick"  },
	{ KEYWORD_TRON , "tron"  },
	{ KEYWORD_TROFF, "troff" },
	{ 0            , ""      }
};

ST_KEYWORDITEM KeyWordsV[] = {
	{ KEYWORD_VARPTR, "varptr" },
	{ KEYWORD_VARSEG, "varseg" },
	{ 0             , ""       }
};

ST_KEYWORDITEM KeyWordsW[] = {
	{ KEYWORD_WAITVB, "waitvb" },
	{ KEYWORD_WAIT  , "wait"   },	// waitwaitvbɂȂ΂ȂȂ
	{ 0             , ""       }
};

ST_KEYWORDITEM KeyWordsX[] = {
	{ KEYWORD_XOR, "xor" },
	{ 0          , ""    }
};

ST_KEYWORDITEM* KeyWordsIndex[26] = {
	KeyWordsA, KeyWordsB, KeyWordsC, KeyWordsD, 
	KeyWordsE, KeyWordsF, KeyWordsG, KeyWordsH, 
	KeyWordsI, NULL,      NULL,      KeyWordsL, 
	KeyWordsM, KeyWordsN, KeyWordsO, KeyWordsP, 
	NULL,      KeyWordsR, KeyWordsS, KeyWordsT, 
	NULL,      KeyWordsV, KeyWordsW, KeyWordsX, 
	NULL,      NULL
};
//---------------------------------------------------------------------------
//lib.c
extern ST_TIMER Timer;

//---------------------------------------------------------------------------
ST_BG          BG0			IN_EWRAM;
ST_SCREEN_TEXT ScreenText	IN_EWRAM;
ST_WONBE       Wonbe		IN_EWRAM;

u8 State;					//is󋵃tO
//---------------------------------------------------------------------------
void StateInit();
void StateLoad();
void StateConvert();
void StateRun();
void StateError();
void StateEnd();


void InitWS();
void InitBG();
void InitKey();
void InitWonbe();
void InitScreenText();
void IRQUserHandler();


bool WonbeLoadFile();
bool WonbeReadLine();
bool WonbeConvertCode();
void WonbeConvertRadix16(u8** src, u8** dst);
bool WonbeConvertRadix10(u8** src, u8** dst);
bool WonbeConvertReserved(u8** src, u8** dst);
bool WonbeConvertString(u8** src, u8** dst);
bool WonbeAppendLine();
void WanbeInterpreter();


//\
void WonbeSt_assignment(s16* pvar);
void WonbeSt_rem();
void WonbeSt_if();
void WonbeSt_print();
void WonbeSt_locate();
void WonbeSt_cls();
void WonbeSt_goto();
void WonbeSt_gosub();
void WonbeSt_return();
void WonbeSt_for();
void WonbeSt_next();
void WonbeSt_end();
void WonbeSt_break();
void WonbeSt_rem();
void WonbeSt_new();
void WonbeSt_list();
void WonbeSt_run();
void WonbeSt_cont();
void WonbeSt_save();
void WonbeSt_load();
void WonbeSt_merge();
void WonbeSt_randomize();
void WonbeSt_exit();
void WonbeSt_debug();
void WonbeSt_waitvb();
void WonbeSt_files();
void WonbeSt_play();
void WonbeSt_poke();
void WonbeSt_call();
void WonbeSt_int();
void WonbeSt_tron();
void WonbeSt_troff();
void WonbeSt_colormode();
void WonbeSt_palette();
void WonbeSt_color();


//ʊ֐
u8   WonbeSkipSpace();
u8*  WonbeSkipToEOL(u8* p);
u8   WonbeMyTolower(u8 ch);
void WonbeMyMemMove(u8* dst, u8* src, u16 len);
void WonbeProcessLineHeader();
s16* WonbeGetArrayReference();
u8*  WonbeGetLineReferenceFromLineNumber(s16 lineNumber);
u8*  WonbeGetInsertionPointFromLineNumber(u16 lineNumber);
bool WonbeIsLetter(u8 chr);
bool WonbeIsNumber(u8 chr);
s16* WonbeDerefArrayItem(s16 index);
s16  WonbeAvailableArrayItem();
s16  WonbeExpr();
s16  WonbeExpr2nd();
s16  WonbeExpr3nd();
s16  WonbeExpr4th();
s16  WonbeCalcValue();
void WonbePtextCLS();
void WonbePtextLocate(s16 argX, s16 argY);
void WonbePtextString(u8* msg);
void WonbePtextNewline();
void WonbePtextTab();
void WonbePrintOrDebug(bool bPrint);
u16  WonbeGBAKeyScan();
u16  WonbeGBAWait();


//G[֐
void WonbeSyntaxError();
void WonbeDivideByZero();
void WonbeReadLineOverflow();
void WonbeOutOfMemory();
void WonbeOutOfArraySubscription();
void WonbeLineNumberZeroError();
void WonbeLineNumberNotFound(u16 lineNumber);
void WonbeNextWithoutFor();
void WonbeStackOverflow();
void WonbeParamError();


//`
void DrawScreenText(u8* str);
void DrawErrorText(u8* str, u16 lineCnt);
void ScrollScreenText();


//fobO
void DebugConvertCode();
void DebugCode();
//---------------------------------------------------------------------------
//Xe[ggs֐̃Xg
typedef void (*NEARPROC)();

NEARPROC statements[KEYWORDS_STATEMENT_TO-KEYWORDS_STATEMENT_FROM+1] = {
	WonbeSt_if,
	WonbeSt_print,
	WonbeSt_locate,
	WonbeSt_cls,
	WonbeSt_goto,
	WonbeSt_gosub,
	WonbeSt_return,
	WonbeSt_for,
	WonbeSt_next,
	WonbeSt_end,
	WonbeSt_break,
	WonbeSt_rem,
	WonbeSt_new,
	WonbeSt_list,
	WonbeSt_run,
	WonbeSt_cont,
	WonbeSt_save,
	WonbeSt_load,
	WonbeSt_merge,
	WonbeSt_randomize,
	WonbeSt_exit,
	WonbeSt_debug,
	WonbeSt_waitvb,
	WonbeSt_files,
	WonbeSt_play,
	WonbeSt_poke,
	WonbeSt_call,
	WonbeSt_int,
	WonbeSt_tron,
	WonbeSt_troff,
	WonbeSt_colormode,
	WonbeSt_palette,
	WonbeSt_color
};
//---------------------------------------------------------------------------
int main()
{
	State = STATE_INIT;

	for(;;)
	{
		WaitForVsync();

		switch(State)
		{
			case STATE_INIT:    StateInit();    break;
			case STATE_LOAD:    StateLoad();    break;
			case STATE_CONVERT: StateConvert(); break;
			case STATE_RUN:     StateRun();     break;
			case STATE_ERROR:   StateError();   break;
			case STATE_END:     StateEnd();     break;

			default:
				DebugMessage((u8*)"Err: Main State");
				break;
		}
	}

	return 0;
}
//---------------------------------------------------------------------------
void StateInit()
{
	InitWS();
	InitBG();
	InitKey();

	InitWonbe();
	InitScreenText();

	SetMode(MODE_0 | BG0_ENABLE | BG2_ENABLE | BG3_ENABLE | OBJ_ENABLE | OBJ_MAP_2D);
	State = STATE_LOAD;
}
//---------------------------------------------------------------------------
void InitWS()
{
	REG_WSCNT = CST_ROM0_1ST_3WAIT | CST_ROM0_2ND_1WAIT;
}
//---------------------------------------------------------------------------
void InitBG()
{
	//BG0 

	BG0.chr = 1;
	BG0.map = 0;
	BG0.col = 0;

	REG_BG0CNT = (BG_SIZEA_256_256     | BG_COLOR_16         |
	              BG_CHARBASE(BG0.chr) | BG_MAPBASE(BG0.map) | 0);

	BGSetPal16  (BG0.col, (u16*)&BGFont_palette);
	BGSetChrData(BG0.chr, (u16*)&BGFont_data, BGFont_DATA_SIZE);
}
//---------------------------------------------------------------------------
void InitKey()
{
	KeyInit();

	REG_INTERUPT = (u32)IRQUserHandler;		//L[͗p̃^C}ݒ
	REG_IE       = IRQ_BIT_TIMER0;
	REG_IME      = IRQ_MASTER_ON;

	REG_TM0D     = 65536 - 2621;			// (((16*1024*1024) / 64) * 10) / 1000
	REG_TM0CNT   = TM_ENABLE | TM_FREQ_PER_64 | TM_USEIRQ;
}
//---------------------------------------------------------------------------
void IRQUserHandler()
{
	Timer.clockTick += TIMER_INTMS;
	REG_IF = IRQ_BIT_TIMER0;
}
//---------------------------------------------------------------------------
void InitWonbe()
{
	ST_WONBE* p = &Wonbe;

	p->FileOffset      = NULL;		//t@C̊Jnʒu
	p->FileReadOffset  = NULL;		//t@C̓ǂݍݍƗp
	p->ReadLineCnt     = 0;
	p->ReadLine[0]     = LF;		//Ps̓ǂݍ݃obt@
	p->ConvertLine[0]  = LF;		//Ps̒Ԍobt@

	p->Code[0]         = 0;			//sR[hobt@
	p->Code[1]         = 0;
	p->Code[2]         = 0;
	p->Code[3]         = 0;
	p->Code[4]         = EOL;
	p->CodeTop         = 0;
	p->DataTop         = 5;

	s16 i;
	for(i=0; i<WONBE_VARIABLE_SIZE; i++)
	{
		p->GlobalVal  [i] = 0;
		p->TopLevelVal[i] = 0;
	}
	p->LocalVal = p->TopLevelVal;	//XR[vŗLȃ[Jϐ̈

	for(i=0; i<(KEYWORD_ES - KEYWORD_AX + 1); i++)
	{
		p->Register[i] = 0x0000;
	}
	p->Defseg = 0x0000;

	p->ExecPointer = NULL;
}
//---------------------------------------------------------------------------
void InitScreenText()
{
	ST_SCREEN_TEXT* p = &ScreenText;

	p->x      = 0;
	p->y      = 0;
	p->wy     = 0;
	p->BGvofs = 0;

	BGDrawCls(BG0.map, ' ');

	DrawScreenText((u8*)"------------------------------");
	DrawScreenText((u8*)" Wonbe GBA--                  ");
	DrawScreenText((u8*)" Tiny BASIC Interpreter       ");
	DrawScreenText((u8*)"------------------------------");
	DrawScreenText((u8*)"                              ");
	DrawScreenText((u8*)"This program is               ");
	DrawScreenText((u8*)"distributed under GNU General ");
	DrawScreenText((u8*)"Public License.               ");
	DrawScreenText((u8*)"                              ");
}
//---------------------------------------------------------------------------
void DrawScreenText(u8* str)
{
	ST_SCREEN_TEXT* p = & ScreenText;

	u16 i = 0;
	while(str[i] != 0x00 && str[i] != 0x0a)
	{
		if(str[i] <= 0x7f)
		{
			//1bytechar
			BGDrawChar(BG0.map, p->x, p->wy, 0, (u16)str[i++]);

			p->x++;
			if(p->x >= SCREEN_TEXT_CX)
			{
				p->x  = 0;
				p->y  = (p->y  + 1);
				p->wy = (p->wy + 1) % SCREEN_TEXT_WCY;
			}

			//s`FbN
			if(p->y >= SCREEN_TEXT_CY)
			{
				ScrollScreenText();
				p->y--;
			}
		}
		else
		{
			//2bytechar
			//\ȂŃXLbv܂
			i+=2;
		}
	}
}
//---------------------------------------------------------------------------
void ScrollScreenText()
{
	ST_SCREEN_TEXT* p = &ScreenText;
	u8 deleteLine     = ( p->wy + 1 ) % SCREEN_TEXT_WCY;

	//Ps݂̏폜
	BGDrawStr(BG0.map, 0, deleteLine , (u8*)"                              ");

	//XN[
	p->BGvofs   = (p->BGvofs + BG_CY) % SCREEN_CY;
	REG_BG0VOFS = (p->BGvofs);
}
//---------------------------------------------------------------------------
void StateLoad()
{
	DrawScreenText((u8*)"Load Source File...           ");

	//t@Cǂݍ܂ꂽ`FbN܂
	if( WonbeLoadFile() == TRUE )
	{
		State = STATE_CONVERT;
		return;
	}

	DrawScreenText((u8*)"Err: File Not Found.");
	State = STATE_ERROR;
}
//---------------------------------------------------------------------------
bool WonbeLoadFile()
{
	ST_WONBE* p   = &Wonbe;
	u8* offset    = SRAMGetOffset(WONBE_FILE_START_OFFSET);

	p->FileOffset     = offset;
	p->FileReadOffset = offset;

	//t@C̐擪ɁA܂Ă邩mF܂
	if(*offset == 0x00)
	{
		return FALSE;
	}
	if(*offset == 0xff)
	{
		return FALSE;
	}

	return TRUE;
}
//---------------------------------------------------------------------------
void StateConvert()		//RRWonbeSuperMain̂Ȃł
{
	DrawScreenText((u8*)"Convert Source File...        ");

	for(;;)
	{
		//\[XPsǂݍ݂܂
		if( WonbeReadLine() == FALSE )
		{
			WonbeReadLineOverflow();
			return;
		}

		//\[XǂݏI`FbN܂
		if(State == STATE_RUN)
		{
			//I
			DrawScreenText((u8*)"Please Push A Button.         ");
//DebugCode();
			WaitKey(KEY_A);
			return;
		}

		//Ps𒆊Ԍɖ|󂵂܂
		if( WonbeConvertCode() == FALSE )
		{
			WonbeSyntaxError();
			return;
		}
//DebugConvertCode();
		//vÖɂPs̒Ԍi[܂
		if( WonbeAppendLine() == FALSE )
		{
			//G[͓ŌʑΉĂ܂
			return;
		}
	}
}
//---------------------------------------------------------------------------
//Ԍs܂
void StateRun()
{
	ST_WONBE* p    = &Wonbe;
	p->ExecPointer = &p->Code[p->CodeTop];

	WanbeInterpreter();

	if(State == STATE_ERROR)
	{
		return;
	}

	//܂łꂽ琳I
	State = STATE_END;
}
//---------------------------------------------------------------------------
void StateEnd()
{
	DrawScreenText((u8*)"OK.");

	for(;;){}
}
//---------------------------------------------------------------------------
//\[X1sǂݍ݂܂
bool WonbeReadLine()
{
	ST_WONBE* p = &Wonbe;
	u16 readCnt = 0;

	if(*p->FileReadOffset == 0x00)
	{
		//ǂݍݏI
		State = STATE_RUN;
		return TRUE;
	}
	if(*p->FileReadOffset == 0xff)
	{
		//ǂݍݏI
		State = STATE_RUN;
		return TRUE;
	}

	for(;;)
	{
		p->ReadLine[readCnt] = *p->FileReadOffset++;

		if(p->ReadLine[readCnt] == LF)	//LF = 0x0a
		{
			break;
		}

		if(readCnt >= WONBE_READ_LINE_SIZE - 1)
		{
			return FALSE;
		}

		readCnt++;
	}

	//sR[hCR+LFꍇCRR[h΍
	if(p->ReadLine[readCnt-1] == CR)	//CR = 0x0d
	{
		p->ReadLine[readCnt-1] = LF;
	}

	p->ReadLineCnt++;
	return TRUE;
}
//---------------------------------------------------------------------------
//ǂݍ񂾃\[Xt@Ci1sj𒆊Ԍɖ|󂵂܂
bool WonbeConvertCode()
{
	ST_WONBE* p = &Wonbe;
	u8* src     = p->ReadLine;
	u8* dst     = p->ConvertLine;

	for(;;)
	{
		//dprintf("Convert: %x %x, ->%x\n", src, *src, dst);

		if(*src == LF  ) break;
		if(*src == '\0') break;
		if(*src == '\n') break;
		if(*src == '\r') break;

		if(*src == ' ' || *src == '\t')
		{
			*dst++ = *src++;
			continue;
		}

		if(*src < 0x20)
		{
			return FALSE;
		}

		//l
		if( WonbeIsNumber(*src) == TRUE )
		{
			//16i
			if(*src == '0' && *(src+1) == 'x')
			{
				*dst = 0x02;
				dst += 1;
				src += 2;

				WonbeConvertRadix16(&src, &dst);
				continue;
			}
			else
			{
				//10i
				*dst = 0x01;
				dst += 1;

				if( WonbeConvertRadix10(&src, &dst) == FALSE )
				{
					//overflow case
					return FALSE;
				}
				continue;
			}
		}

		//At@xbg
		if( WonbeIsLetter(*src) == TRUE )
		{
			//̕AAt@xbg`FbN܂
			if( WonbeIsLetter( *(src+1) ) == TRUE )
			{
				//\ꂩ`FbN܂
				if( WonbeConvertReserved(&src, &dst) == FALSE )
				{
					return FALSE;
				}
				continue;

			}
			else
			{
				*dst++ = *src++;
				continue;
			}
		}

		//Rg
		if(*src == '\'')
		{
			*dst++ = *src++;

			//Rg̏ꍇ͍s܂ŉ̂܂܃Rs[܂
			while(*src != LF)
			{
				*dst++ = *src++;
			}
			continue;
		}

		//񔻒
		if(*src == '"')
		{
			*dst++ = 0x03;
			src++;

			if( WonbeConvertString(&src, &dst) == FALSE )
			{
				return FALSE;
			}
			continue;
		}

		//̂܂܃Rs[܂
		*dst++ = *src++;
		continue;

	}// for(;;)

	*dst = EOL;
	return TRUE;
}
//---------------------------------------------------------------------------
void WonbeConvertRadix16(u8** src, u8** dst)
{
	u16 num = 0;

	for(;;)
	{
		if(**src >= '0' && **src <= '9')
		{
			num *= 16;
			num += **src - '0';
		}
		else if(**src >= 'a' && **src <= 'f')
		{
			num *= 16;
			num += **src - 'a' + 10;
		}
		else if(**src >= 'A' && **src <= 'F')
		{
			num *= 16;
			num += **src - 'A' + 10;
		}
		else
		{
			break;
		}

		*src += 1;
	}

	**dst = (num & 0xff00) >> 8; *dst += 1;
	**dst = (num & 0x00ff);      *dst += 1;
}
//---------------------------------------------------------------------------
bool WonbeConvertRadix10(u8** src, u8** dst)
{
	s16 num = 0;

	num = **src - '0';
	*src += 1;

	for(;;)
	{
		if(**src < '0' || **src > '9') break;

		num  *= 10;
		num  += **src - '0';
		*src += 1;

		if(num < 0)
		{
			//overflow case
			return FALSE;
		}
	}

	**dst = (num & 0xff00) >> 8; *dst += 1;
	**dst = (num & 0x00ff);      *dst += 1;

	return TRUE;
}
//---------------------------------------------------------------------------
bool WonbeConvertReserved(u8** src, u8** dst)
{
	//*src̐擪iu8PʁjCfbNXɂāA\e[uĂ܂B
	//\e[ua`z܂B
	ST_KEYWORDITEM* p = KeyWordsIndex[ WonbeMyTolower(**src) - 'a' ];

	if(p == NULL)
	{
		return FALSE;
	}

	u8* ps;
	u8* pd;

	for(;;)
	{
		ps = *src;
		pd = p->name;

		//\ꂩ`FbN܂
		for(;;)
		{
			if(*pd == '\0')
			{
				**dst  = p->id;
				*dst  += 1;
				*src   = ps;

				goto nextStep;
			}

			if( WonbeMyTolower(*ps) != WonbeMyTolower(*pd) )
			{
				break;
			}

			ps++;
			pd++;
		}

		p++;					//̗\Zbg܂
		if(p->id == 0)
		{
			return FALSE;
		}
	}

nextStep:

	if(p->id == KEYWORD_REM)
	{
		//Rg̏ꍇ͍s܂ŉ̂܂܃Rs[܂
		while(**src != LF)
		{
			**dst = **src;
			*dst += 1;
			*src += 1;
		}
	}

	return TRUE;
}
//---------------------------------------------------------------------------
bool WonbeConvertString(u8** src, u8** dst)
{
	for(;;)
	{
		if(**src == LF)
		{
			return FALSE;
		}

		if(**src == '"')
		{
			break;
		}

		**dst = **src;
		*dst += 1;
		*src += 1;
	}

	**dst   = '\0';
	*dst   += 1;
	*src   += 1;

	return TRUE;
}
//---------------------------------------------------------------------------
bool WonbeAppendLine()
{
	ST_WONBE* p = &Wonbe;

	//擪sԍij`FbN܂
	if(p->ConvertLine[0] != 0x01)
	{
		WonbeSyntaxError();
		return FALSE;
	}

	//sԍ 0`FbN܂
	u16 wishLineNumber = (p->ConvertLine[1] << 8) | (p->ConvertLine[2]);
	if(wishLineNumber == 0)
	{
		WonbeLineNumberZeroError();
		return FALSE;
	}

	//vÖɊi[ꍇ
	//擪2oCg̍sԍƁA2oCg̍si[iv4oCgj

	u8* tp         = p->ConvertLine + 3;									//sJbg|C^
	u8* target     = WonbeGetInsertionPointFromLineNumber(wishLineNumber);	//vÖ̊i[\|C^
	u16 lineNumber = *target | *(target+1) << 8;							//vÖ̍sԍ

	u8 ch;
	for(;;)
	{
		ch = *tp++;

		if(ch != ' ' && ch != '\t')
		{
			break;
		}
	}

	//sԍ̓͂́A̍sԍ폜܂
	if(ch == EOL)
	{
		//removing the line
		if(lineNumber == 0 || lineNumber != wishLineNumber)
		{
			WonbeLineNumberNotFound(wishLineNumber);
			return FALSE;
		}

		u8* from = WonbeSkipToEOL(target + 4) + 1;

		WonbeMyMemMove(target, from, (u16)(p->DataTop - (from - p->Code)) );
		p->DataTop -= from - target;

		return TRUE;
	}

	//vÖɎ߂Ƃ̃TCY
	//-10x01̕B+2͒B+1EOL
	u16 len = WonbeSkipToEOL(tp) - p->ConvertLine - 1 + 2 + 1;

	//vÖ̊i[\sԍƁAԌɏĂsԍƔׂ܂
	if(lineNumber != wishLineNumber)
	{
		//insert new line
		if(p->DataTop + len >= WONBE_WORK_SIZE)
		{
			WonbeOutOfMemory();
			return FALSE;
		}
		WonbeMyMemMove(target+len, target, (u16)(p->DataTop - (target - p->Code)) );
		p->DataTop += len;
	}
	else
	{
		//replace line
		u8* nextline = WonbeSkipToEOL(target + 4);		//sԍ2oCg+s2oCg
		u16 lost     = nextline - target;
		u32 delta    = len      - lost;

		if(p->DataTop + delta >= WONBE_WORK_SIZE)
		{
			WonbeOutOfMemory();
			return FALSE;
		}
		WonbeMyMemMove(nextline+delta, nextline, (u16)(p->DataTop - (nextline - p->Code)) );
		p->DataTop += delta;
	}

	*(target + 0) = (u8)p->ConvertLine[2];				//s̔ԍi2oCgj
	*(target + 1) = (u8)p->ConvertLine[1];
	*(target + 2) = (len & 0x00ff);						//s̒i2oCgj
	*(target + 3) = (len & 0xff00) >> 8;

	WonbeMyMemMove(target+4, p->ConvertLine+3, len-4);	//c̖ߌRs[܂

	return TRUE;
}
//---------------------------------------------------------------------------
void WanbeInterpreter()
{
	ST_WONBE* p = &Wonbe;
	u8 ch;

	for(;;)
	{
		//s̊JnԍȂǂǂݎ܂
		WonbeProcessLineHeader();

		//Ō܂Ŏs`FbN܂
		if(p->ReadLineCnt == 0)
		{
			return;
		}

		for(;;)
		{
			ch = *p->ExecPointer++;

			//dprintf("Interpreter: %x %d %x\n", ch, p->ReadLineCnt, p->ExecPointer-1);

			if(ch == EOL)
			{
				break;
			}

			if(ch == ' ' || ch == '\t' || ch == ':')
			{
				continue;
			}

			if(ch == '\'')			//Rg
			{
				WonbeSt_rem();
				continue;
			}

			if(ch == '@')			//zϐ
			{
				s16* pvar = WonbeGetArrayReference();
				if(pvar == NULL)
				{
					return;
				}

				WonbeSt_assignment(pvar);
				continue;
			}

			if(ch >= 'A' && ch <= 'Z')
			{
				WonbeSt_assignment( &p->GlobalVal[ch-'A'] );
				continue;
			}

			if(ch >= 'a' && ch <= 'z')
			{
				WonbeSt_assignment( &p->LocalVal[ch-'a'] );
				continue;
			}

			if(ch >= KEYWORD_AX && ch <= KEYWORD_ES)
			{
				WonbeSt_assignment( &p->Register[ch - KEYWORD_AX] );
				continue;
			}

			if(ch == KEYWORD_DEFSEG)
			{
				WonbeSt_assignment( &p->Defseg );
				continue;
			}

			if(ch >= KEYWORDS_STATEMENT_FROM && ch <= KEYWORDS_STATEMENT_TO)
			{
				(*(statements[ch - KEYWORDS_STATEMENT_FROM]))();
				continue;
			}

			if( ch == '?' )
			{
				WonbeSt_debug();
				continue;
			}

			WonbeSyntaxError();
			return;
		}
	}
}
//---------------------------------------------------------------------------
void WonbeSt_rem()
{
	ST_WONBE* p    = &Wonbe;
	p->ExecPointer = WonbeSkipToEOL(p->ExecPointer);
}
//---------------------------------------------------------------------------
//Xe[ggOIɏ
void WonbeSt_assignment(s16* pvar)
{
	u8 ch = WonbeSkipSpace();

	if(ch != '=')
	{
		WonbeSyntaxError();
		return;
	}

	s16 val = WonbeExpr();

	if(State == STATE_ERROR)
	{
		return;
	}

	*((u8*)pvar + 0) = (val & 0x00ff);
	*((u8*)pvar + 1) = (val & 0xff00) >> 8;
}
//---------------------------------------------------------------------------
s16* WonbeGetArrayReference()
{
	s16  index;
	s16* pvar;
	u8  ch = WonbeSkipSpace();

	if(ch != '(' && ch != '[')
	{
		WonbeSyntaxError();
		return NULL;
	}

	index = WonbeExpr();
	pvar  = WonbeDerefArrayItem(index);

	if(pvar == NULL)
	{
		return NULL;
	}

	ch = WonbeSkipSpace();

	if(ch != ')' && ch != ']')
	{
		WonbeSyntaxError();
		return NULL;
	}

	return pvar;
}
//---------------------------------------------------------------------------
s16* WonbeDerefArrayItem(s16 index)
{
	ST_WONBE* p = &Wonbe;

	if( index < 0 || index >= WonbeAvailableArrayItem() )
	{
		WonbeOutOfArraySubscription();						//̃CfbNX͔͈͊O
		return NULL;
	}

	return (s16*)(p->Code + p->DataTop + index*2);
}
//---------------------------------------------------------------------------
s16 WonbeAvailableArrayItem()
{
	ST_WONBE* p = &Wonbe;
	return (WONBE_WORK_SIZE - p->DataTop) >> 1;
}
//---------------------------------------------------------------------------
s16 WonbeExpr()
{
	s16 acc = WonbeExpr2nd();

	if(State == STATE_ERROR)
	{
		return -1;
	}

	u8 ch;
	for(;;)
	{
		ch = WonbeSkipSpace();

		switch(ch)
		{
		case KEYWORD_AND: acc = acc & WonbeExpr2nd(); break;
		case KEYWORD_OR:  acc = acc | WonbeExpr2nd(); break;
		case KEYWORD_XOR: acc = acc ^ WonbeExpr2nd(); break;

		default:
			Wonbe.ExecPointer--;		//unget it
			return acc;
		}

		if(State == STATE_ERROR) return -1;
	}
}
//---------------------------------------------------------------------------
s16 WonbeExpr2nd()
{
	s16 acc = WonbeExpr3nd();

	if(State == STATE_ERROR)
	{
		return -1;
	}

	u8 ch, ch2;
	for(;;)
	{
		ch = WonbeSkipSpace();

		switch(ch)
		{
		case '>':
			ch2 = WonbeSkipSpace();

			if(ch2 == '=')
			{
				acc = ( acc >= WonbeExpr3nd() );
			}
			else
			{
				Wonbe.ExecPointer--;
				acc = ( acc > WonbeExpr3nd() );
			}
			break;

		case '<':
			ch2 = WonbeSkipSpace();

			if(ch2 == '=')
			{
				acc = ( acc <= WonbeExpr3nd() );
			}
			else if(ch2 == '>')
			{
				acc = ( acc != WonbeExpr3nd() );
			}
			else
			{
				Wonbe.ExecPointer--;
				acc = ( acc < WonbeExpr3nd() );
			}
			break;

		case '=':
			acc = ( acc == WonbeExpr3nd() );
			break;

		default:
			Wonbe.ExecPointer--;		//unget it
			return acc;
		}

		if(acc != 0)
		{
			acc = -1;
		}

		if(State == STATE_ERROR) return -1;
	}
}
//---------------------------------------------------------------------------
s16 WonbeExpr3nd()
{
	s16 acc = WonbeExpr4th();

	if(State == STATE_ERROR)
	{
		return -1;
	}

	u8 ch;
	for(;;)
	{
		ch = WonbeSkipSpace();

		switch(ch)
		{
		case '+': acc = acc + WonbeExpr4th(); break;
		case '-': acc = acc - WonbeExpr4th(); break;
		default:
			Wonbe.ExecPointer--;		//unget it
			return acc;
		}

		if(State == STATE_ERROR) return -1;
	}
}
//---------------------------------------------------------------------------
s16 WonbeExpr4th()
{
	s16 acc = WonbeCalcValue();

	if(State == STATE_ERROR)
	{
		return -1;
	}

	s8  ch;
	s16 t;
	for(;;)
	{
		ch = WonbeSkipSpace();

		switch(ch)
		{
		case '*':
			acc = acc * WonbeCalcValue();
			break;

		case '/':
			t = WonbeCalcValue();

			if( t == 0 ) WonbeDivideByZero();
			else         acc = acc / t;

			break;

		default:
			Wonbe.ExecPointer--;		//unget it
			return acc;
		}

		if(State == STATE_ERROR) return -1;
	}
}
//---------------------------------------------------------------------------
s16 WonbeCalcValue()
{
	ST_WONBE* p = &Wonbe;
	u8 ch       = WonbeSkipSpace();

	if( ch >= 'A' && ch <= 'Z' )
	{
		return p->GlobalVal[ch-'A'];
	}
	if( ch >= 'a' && ch <= 'z' )
	{
		return p->LocalVal[ch-'a'];
	}

	if( ch == '@' )
	{
		s16* pvar;
		pvar = WonbeGetArrayReference();

		if(pvar == NULL)
		{
			return -1;
		}

		return *pvar;
	}

	if( ch >= KEYWORD_AX && ch <= KEYWORD_ES )
	{
		return p->Register[ch-KEYWORD_AX];
	}

	s16 t;
	switch(ch)
	{
	case 0x01:	//ɂ̂10i2oCg
	case 0x02:	//ɂ̂16i2oCg
		t  = *(p->ExecPointer + 0) << 8;
		t |= *(p->ExecPointer + 1);

		p->ExecPointer += 2;
		return t;

	case '(':
		t  = WonbeExpr();

		ch = WonbeSkipSpace();
		if(ch != ')')
		{
			WonbeSyntaxError();
			return -1;
		}
		return t;

	case '-':
		return -WonbeCalcValue();

	case KEYWORD_NOT:
		return ~WonbeCalcValue();

	case KEYWORD_SCAN:
		return WonbeGBAKeyScan();

	case KEYWORD_WAIT:
		return WonbeGBAWait();

	case KEYWORD_RND:
		t = WonbeCalcValue();
		return rand() % t;

	case KEYWORD_ABS:
		t = WonbeCalcValue();
		if( t < 0 ) return -t;
		else        return  t;

	case KEYWORD_TICK:
		return 0; //win32_get_tick_count(); DUMMY VALUE

	case KEYWORD_SCAN_A:   return 4;				//KEY_A
	case KEYWORD_SCAN_B:   return 8;				//KEY_B
	case KEYWORD_SCAN_X1:  return 16;				//KEY_UP
	case KEYWORD_SCAN_X2:  return 32;				//KEY_RIGHT
	case KEYWORD_SCAN_X3:  return 64;				//KEY_DOWN
	case KEYWORD_SCAN_X4:  return 128;				//KEY_LEFT
	case KEYWORD_SCAN_Y1:  return 256;				//no used
	case KEYWORD_SCAN_Y2:  return 512;				//no used
	case KEYWORD_SCAN_Y3:  return 1024;				//no used
	case KEYWORD_SCAN_Y4:  return 2048;				//no used
	case KEYWORD_HARDARCH: return 0;				//DUMMY VALUE
	case KEYWORD_DEFSEG:   return p->Defseg;
	case KEYWORD_DSEG:     return 0;				//DUMMY VALUE
	case KEYWORD_CSEG:     return 0;				//DUMMY VALUE
	case KEYWORD_SSEG:     return 0;				//DUMMY VALUE
	case KEYWORD_VARPTR:   return 0;				//DUMMY VALUE
	case KEYWORD_VARSEG:   return 0;				//DUMMY VALUE
	case KEYWORD_PEEK:     return 0;				//DUMMY VALUE
	}

	WonbeSyntaxError();
	return -1;
}
//---------------------------------------------------------------------------
u16 WonbeGBAKeyScan()
{
	KeyRepeat();							//keyGet֐ĂԑOɕKsȂ

	u8     key = KeyGet();
	u16 retKey = 0x0000;

	if(key & KEY_UP   ) retKey |=  16;		// x1
	if(key & KEY_DOWN ) retKey |=  64;		// x3
	if(key & KEY_LEFT ) retKey |= 128;		// x4
	if(key & KEY_RIGHT) retKey |=  32;		// x2
	if(key & KEY_A    ) retKey |=   4;		// A
	if(key & KEY_B    ) retKey |=   8;		// B

	return retKey;
}
//---------------------------------------------------------------------------
u16 WonbeGBAWait()
{
start:

	WaitForVsync();

	if( KeyWaitTimer() == TRUE )
	{
		goto start;
	}
	if( KeyRepeat() == TRUE )				//keyGet֐ĂԑOɕKsȂ
	{
		goto start;
	}

	u8 key = KeyGet();
	if(key == 0x00)
	{
		goto start;
	}

	return WonbeGBAKeyScan();
}
//---------------------------------------------------------------------------
void WonbeProcessLineHeader()
{
	ST_WONBE* p = &Wonbe;

	p->ReadLineCnt  = *p->ExecPointer | *(p->ExecPointer+1) << 8;
	p->ExecPointer += 4;						// +4͍sԍ2oCg
}
//---------------------------------------------------------------------------
u8* WonbeSkipToEOL(u8* p)
{
	for(;;)
	{
		if(*p == EOL) return p;

		switch( *p++ )
		{
		case 0x01:			//ɂ̂10i2oCg
		case 0x02:			//ɂ̂16i2oCg
			p += 2;
			break;
		case 0x03:			//ɂ͉̂ϒ 0x00Ń^[~l[g
			for(;;)
			{
				if( *p++ == '\0' ) break;
			}
			break;
		}
	}
}
//---------------------------------------------------------------------------
void WonbeMyMemMove(u8* dst, u8* src, u16 len)
{
	s32 i;
	if(dst < src)
	{
		for(i=0; i<len; i++)
		{
			*dst++ = *src++;
		}
	}
	else
	{
		dst += len;
		src += len;

		for(i=0; i<len; i++)
		{
			*--dst = *--src;
		}
	}
}
//---------------------------------------------------------------------------
u8 WonbeMyTolower(u8 ch)
{
	return (ch >= 'A' && ch <= 'Z') ? (ch - 'A' + 'a') : (ch);
}
//---------------------------------------------------------------------------
void StateError()
{
	
}
//---------------------------------------------------------------------------
u8 WonbeSkipSpace()
{
	u8 ch;

	for(;;)
	{
		ch = *Wonbe.ExecPointer++;

		if(ch != ' ' && ch != '\t')
		{
			break;
		}
	}

	return ch;
}
//---------------------------------------------------------------------------
void WonbeSt_if()
{
	s16 val;
	u8  ch;

	val = WonbeExpr();

	if(State == STATE_ERROR)
	{
		return;
	}

	ch = WonbeSkipSpace();

	if(ch != KEYWORD_THEN)
	{
		WonbeSyntaxError();
		return;
	}

	if(val != 0)
	{
		for(;;)
		{
			ch = *Wonbe.ExecPointer;
			if(ch != ' ' && ch != '\t')
			{
				break;
			}

			*Wonbe.ExecPointer++;
		}

		if(ch == 0x01)
		{
			//then̂Ƃɐڏꂽꍇgoto܂
			WonbeSt_goto();
			return;
		}

		//then̎ps܂
		return;
	}

	//sɂAs܂œǂݔ΂܂
	Wonbe.ExecPointer = WonbeSkipToEOL(Wonbe.ExecPointer);
}
//---------------------------------------------------------------------------
void WonbeSt_print()
{
	WonbePrintOrDebug(TRUE);
}
//---------------------------------------------------------------------------
void WonbeSt_debug()
{
//	printOrDebug( FALSE );
}
//---------------------------------------------------------------------------
void WonbePrintOrDebug(bool bPrint)
{
	ST_WONBE* p = &Wonbe;
	u16 lastChar;
	u8  ch;
	s16 val;
	u8  str[10];
	lastChar = '\0';

	for(;;)
	{
		ch = WonbeSkipSpace();

		if(ch == EOL || ch == ':' || ch == '\'')
		{
			p->ExecPointer--;		//unget it
			break;
		}

		lastChar = ch;

		switch(ch)
		{
		case 0x03:
			if(bPrint)
			{
				WonbePtextString(p->ExecPointer);
			}
			else
			{
				//commonPrint(NULL, p->ExecPointer);
			}

			for(;;)
			{
				ch = *p->ExecPointer++;
				if(ch == '\0')
				{
					break;
				}
			}
			break;

		case ';':
			break;

		case ',':
			if(bPrint)
			{
				WonbePtextTab();
			}
			else
			{
				//commonPrint(NULL, "\t");
			}
			break;

		case KEYWORD_CHR:
			val = WonbeExpr();

			if(State == STATE_ERROR) return;

			if(val >= 0x100)
			{
				str[0] = (val >> 8);
				str[1] = (val & 0xff);
				str[2] = '\0';
			}
			else
			{
				str[0] = val;
				str[1] = '\0';
			}

			if(bPrint)
			{
				WonbePtextString(str);
			}
			else
			{
				//commonPrint(NULL, str);
			}
			break;

		default:
			Wonbe.ExecPointer--;	//unget it
			val = WonbeExpr();

			if(State == STATE_ERROR) return;

			bprintf((char*)str, "%d", val);

			if(bPrint)
			{
				WonbePtextString(str);
			}
			else
			{
				//commonPrint(NULL, str);
			}
			break;

		} //switch(ch)
	} //for(;;)

	if(lastChar != ';' && lastChar != ',')
	{
		if(bPrint)
		{
			WonbePtextNewline();
		}
		else
		{
			//commonPrint(NULL, NEWLINE);
		}
	}
}
//---------------------------------------------------------------------------
void WonbePtextTab()
{
	ST_SCREEN_TEXT* p = &ScreenText;

	if(p->x + WONBE_TABSTOP >= SCREEN_TEXT_CX)
	{
		WonbePtextNewline();
		return;
	}

	p->x = (p->x + WONBE_TABSTOP) / WONBE_TABSTOP * WONBE_TABSTOP;
}
//---------------------------------------------------------------------------
void WonbePtextNewline()
{
	ST_SCREEN_TEXT* p = &ScreenText;

	p->x  = 0;
	p->y  = (p->y  + 1);
	p->wy = (p->wy + 1) % SCREEN_TEXT_WCY;

	//s`FbN
	if(p->y >= SCREEN_TEXT_CY)
	{
		ScrollScreenText();
		p->y--;
	}
}
//---------------------------------------------------------------------------
void WonbePtextString(u8* msg)
{
	DrawScreenText(msg);
}
//---------------------------------------------------------------------------
void WonbeSt_locate()
{
	s16 x, y;
	u8  ch;

	x = WonbeExpr();
	if(State == STATE_END) return;

	ch = WonbeSkipSpace();

	if(ch != ',')
	{
		WonbeSyntaxError();
		return;
	}

	y = WonbeExpr();
	if(State == STATE_END) return;

	WonbePtextLocate( x, y );
}
//---------------------------------------------------------------------------
void WonbeSt_cls()
{
	WonbePtextCLS();
}
//---------------------------------------------------------------------------
void WonbePtextCLS()
{
	s16 x,y;
	for(y=0; y<SCREEN_TEXT_WCY; y++)
	{
		for(x=0; x<SCREEN_TEXT_WCX; x++)
		{
			BGDrawStr(BG0.map, x, y, (u8*)" ");
		}
	}

	ScreenText.x  = 0;
	ScreenText.y  = 0;
	ScreenText.wy = 0;
}
//---------------------------------------------------------------------------
void WonbeSt_goto()
{
	s16 val;
	u8* t;

	val = WonbeExpr();

	if( State == STATE_ERROR ) return;

	t = WonbeGetLineReferenceFromLineNumber( (u16)val );
	if(t == NULL)
	{
		WonbeLineNumberNotFound(val);
		return;
	}

	Wonbe.ExecPointer = t;
	WonbeProcessLineHeader();
}
//---------------------------------------------------------------------------
void WonbeSt_gosub()
{
	ST_WONBE* p = &Wonbe;
	u16 val;
	u8* t;

	val = WonbeExpr();

	if(State == STATE_ERROR) return;

	t = WonbeGetLineReferenceFromLineNumber(val);
	if(t == NULL)
	{
		WonbeLineNumberNotFound(val);
		return;
	}

	if(p->StackCnt + 1 >= WONBE_STACK_MAX)
	{
		WonbeStackOverflow();
		return;
	}

	p->Stack[p->StackCnt].Type          = WONBE_STACK_TYPE_GOSUB;
	p->Stack[p->StackCnt].ReturnPointer = p->ExecPointer;
	p->Stack[p->StackCnt].LastLocalVal  = p->LocalVal;

	p->LocalVal = p->Stack[p->StackCnt].SimpleVal;
	p->StackCnt++;

	p->ExecPointer = t;
	WonbeProcessLineHeader();
}
//---------------------------------------------------------------------------
void WonbeSt_return()
{
	ST_WONBE* p = &Wonbe;

	for(;;)
	{
		if(p->StackCnt == 0)
		{
			WonbeNextWithoutFor();
			return;
		}
		p->StackCnt--;

		if(p->Stack[p->StackCnt].Type == WONBE_STACK_TYPE_GOSUB)
		{
			break;
		}
	}

	p->ExecPointer = p->Stack[p->StackCnt].ReturnPointer;
	p->LocalVal    = p->Stack[p->StackCnt].LastLocalVal;
}
//---------------------------------------------------------------------------
void WonbeSt_for()
{
	ST_WONBE* p = &Wonbe;

	u8 ch = WonbeSkipSpace();
	s16* pvar;
	s16  from, to, step;

	//is it l-value?
	if(ch == '@')
	{
		pvar = WonbeGetArrayReference();
		if(pvar == NULL) return;
	}
	else if( ch >= 'A' && ch <= 'Z' )
	{
		pvar = &p->GlobalVal[ch-'A'];
	}
	else if( ch >= 'a' && ch <= 'z' )
	{
		pvar = &p->LocalVal[ch-'a'];
	}
	else
	{
		WonbeSyntaxError();
		return;
	}

	ch = WonbeSkipSpace();

	if(ch != '=')
	{
		WonbeSyntaxError();
		return;
	}

	from = WonbeExpr();
	if(State == STATE_ERROR) return;

	ch = WonbeSkipSpace();

	if(ch != KEYWORD_TO)
	{
		WonbeSyntaxError();
		return;
	}

	to = WonbeExpr();
	if(State == STATE_ERROR) return;

	ch = WonbeSkipSpace();

	if(ch == KEYWORD_STEP)
	{
		step = WonbeExpr();
		if(State == STATE_ERROR) return;
	}
	else
	{
		step = 1;
		p->ExecPointer--;	//unget it
	}

	if(p->StackCnt+1 >= WONBE_STACK_MAX)
	{
		WonbeStackOverflow();
		return;
	}

	p->Stack[p->StackCnt].Type          = WONBE_STACK_TYPE_FOR;
	p->Stack[p->StackCnt].ReturnPointer = p->ExecPointer;

	*pvar = from;
	p->Stack[p->StackCnt].Pvar  = pvar;
	p->Stack[p->StackCnt].Limit = to;
	p->Stack[p->StackCnt].Step  = step;
	p->StackCnt++;
}
//---------------------------------------------------------------------------
void WonbeSt_next()
{
	ST_WONBE* p = &Wonbe;
	ST_STACK* s = &Wonbe.Stack[Wonbe.StackCnt - 1];

	if(p->StackCnt == 0)
	{
		WonbeNextWithoutFor();
		return;
	}

	if(s->Type != WONBE_STACK_TYPE_FOR)
	{
		WonbeNextWithoutFor();
		return;
	}

	if(s->Limit == *(s->Pvar))
	{
		//loop done
		p->StackCnt--;
		return;
	}

	//count step and loop again
	*(s->Pvar) += s->Step;

	//counter overflow?
	if(s->Step > 0)
	{
		if(s->Limit < *(s->Pvar))
		{
			//loop done
			p->StackCnt--;
			return;
		}
	}
	else
	{
		if(s->Limit > *(s->Pvar))
		{
			//loop done
			p->StackCnt--;
			return;
		}
	}

	p->ExecPointer = s->ReturnPointer;
}
//---------------------------------------------------------------------------
void WonbeSt_end()
{
	u8* t = WonbeGetLineReferenceFromLineNumber(0);

	if(t == NULL)
	{
		WonbeLineNumberNotFound(0);
		return;
	}

	Wonbe.ExecPointer = t;
	WonbeProcessLineHeader();

	State = STATE_END;
}
//---------------------------------------------------------------------------
//breakXe[gg:@fobOp̒f
void WonbeSt_break()
{
/*
	commonPrint(NULL, "Break in %d\x7" NEWLINE, currentLineNumber);
	bForceToReturnSuper = TRUE;
	requestNextAction = REQUEST_INTERACTIVE;
	resumePointer = executionPointer;	//contꏊbreak̎Bbreak݂̗̂O
*/
}
//---------------------------------------------------------------------------
void WonbeSt_new()
{
/*
	bForceToReturnSuper = TRUE;
	requestNextAction = REQUEST_NEW;
*/
}
//---------------------------------------------------------------------------
void WonbeSt_list()
{
/*
	WORD from, to;
	BYTE ch;
	while( TRUE ) {
		ch = *executionPointer++;
		if( ch != ' ' && ch != '\t' ) break;
	}
	if( ch == ':' || ch == EOL || ch == '\'' ) {
		executionPointer--;	//unget
		from = 1;
		to = 32767;
	} else {
		if( ch == 0x01 ) {
			from = *((WORD*)executionPointer);
			executionPointer += 2;
			while( TRUE ) {
				ch = *executionPointer++;
				if( ch != ' ' && ch != '\t' ) break;
			}
		} else {
			from = 1;
		}
		if( ch != '-' ) {
			executionPointer--;	//unget
			to = from;
		} else {
			while( TRUE ) {
				ch = *executionPointer++;
				if( ch != ' ' && ch != '\t' ) break;
			}
			if( ch == 0x01 ) {
				to = *((WORD*)executionPointer);
				executionPointer += 2;
			} else {
				executionPointer--;	//unget
				to = 32767;
			}
		}
	}
	sourceDump( NULL, from, to );	//Xgo̖͂{̂Ă
*/
}
//---------------------------------------------------------------------------
void WonbeSt_run()
{
/*
	BYTE ch;
	while( TRUE ) {
		ch = *executionPointer++;
		if( ch != ' ' && ch != '\t' ) break;
	}
	if( ch == ':' || ch == EOL || ch == '\'' ) {
		bForceToReturnSuper = TRUE;
		requestNextAction = REQUEST_RUN_LINENUMBER;
		runLineNumber = 0;
	} else if( ch == 0x03 ) {
		strcpy( waRawLine, executionPointer );
		bForceToReturnSuper = TRUE;
		requestNextAction = REQUEST_RUN_FILE;
	} else {
		SHORT val;
		executionPointer--;	//unget it
		val = expr();
		if( bForceToReturnSuper ) return;
		bForceToReturnSuper = TRUE;
		requestNextAction = REQUEST_RUN_LINENUMBER;
		runLineNumber = val;
	}
*/
}
//---------------------------------------------------------------------------
void WonbeSt_cont()
{
/*
	if( resumePointer == NULL ) {
		cantContinue();
		return;
	}
	executionPointer = resumePointer;
	bInteractive = FALSE;
*/
}
//---------------------------------------------------------------------------
void WonbeSt_save()
{
/*
	BYTE ch;
	BOOL b;
	FILE FAR * fp;
	while( TRUE ) {
		ch = *executionPointer++;
		if( ch != ' ' && ch != '\t' ) break;
	}
	if( ch != 0x03 ) {
		syntaxError();
		return;
	}
	fp = fopen( executionPointer, "w" );
	if( fp == NULL ) {
		saveError();
		return;
	}
	b = sourceDump( fp, 1, 32767 );
	fclose( fp );
	if( b == FALSE ) {
		saveError();
		remove( executionPointer );
		return;
	}

	executionPointer += strlen(executionPointer)+1;
*/
}
//---------------------------------------------------------------------------
void WonbeSt_load()
{
/*
	BYTE ch;
	while( TRUE ) {
		ch = *executionPointer++;
		if( ch != ' ' && ch != '\t' ) break;
	}
	if( ch == 0x03 ) {
		strcpy( waRawLine, executionPointer );
		bForceToReturnSuper = TRUE;
		requestNextAction = REQUEST_LOAD_FILE;
	} else {
		syntaxError();
		return;
	}
*/
}
//---------------------------------------------------------------------------
void WonbeSt_merge()
{
/*
	BYTE ch;
	while( TRUE ) {
		ch = *executionPointer++;
		if( ch != ' ' && ch != '\t' ) break;
	}
	if( ch == 0x03 ) {
		strcpy( waRawLine, executionPointer );
		bForceToReturnSuper = TRUE;
		requestNextAction = REQUEST_MERGE_FILE;
	} else {
		syntaxError();
		return;
	}
*/
}
//---------------------------------------------------------------------------
void WonbeSt_randomize()
{
/*
	SHORT val;
	val = expr();
	srand( val );
*/
}
//---------------------------------------------------------------------------
void WonbeSt_exit()
{
/*
	bForceToReturnSuper = TRUE;
	requestNextAction = REQUEST_EXIT_SYSTEM;
*/
}
//---------------------------------------------------------------------------
void WonbeSt_waitvb()
{
	s16 val;

	val = WonbeExpr();
	if(State == STATE_ERROR)
	{
		return;
	}

	if(val < 0 || val > 750)
	{
		WonbeParamError();
		return;
	}

	WaitMs((u32)val * 10);
}
//---------------------------------------------------------------------------
void WonbeSt_files()
{
/*
#ifdef WIN32
	commonPrint( NULL, "files statement not implemented in Win32\x7" NEWLINE );
#endif
#ifdef WW
	int i;
	struct stat statbuf;
	int nent;

	//chdir("/rom0");
	nent = nument(NULL);

	for (i = 0; i < nent; i++) {
		int result = getent(NULL, i, &statbuf);
		if (result == E_FS_SUCCESS) {
			if (statbuf.count != -1) {
				//Freya OS̃oO?@R[h
				int p, q;
				p = 0;
				q = 0;
				waRawLine[p++] = '"';
				while( TRUE ) {
					if( statbuf.name[q] == '\0' ) break;
					waRawLine[p++] = statbuf.name[q++];
				}
				waRawLine[p++] = '"';
				waRawLine[p++] = ',';
				q = 0;
				while( TRUE ) {
					if( statbuf.info[q] == '\0' ) break;
					waRawLine[p++] = statbuf.info[q++];
				}
				waRawLine[p++] = '\0';
				commonPrint( NULL, "%s,%ld,%d" NEWLINE, waRawLine, statbuf.len, statbuf.count );
			}
		} else {
			commonPrint( NULL, "*File Access Error\x7" NEWLINE );
		}
	}
#endif
*/
}
//---------------------------------------------------------------------------
void WonbeSt_play()
{
/*
	BYTE ch;

	ch = *executionPointer++;
	while ( ch == ' ' || ch == '\t' ) {
		ch = *executionPointer++;
	}
	if ( ch != 0x03 ) {
		syntaxError();
		return;
	}
 
#ifdef WIN32
	win32_play_mml( executionPointer );
#endif
#ifdef WW
	if ( soundAvailable ) {
		parse_mml( _heap, executionPointer, 0 );
		bgm_play( _heap, PLAY_SINGLE );
	}
#endif

	executionPointer += strlen(executionPointer)+1;
*/
}
//---------------------------------------------------------------------------
void WonbeSt_poke()
{
/*
	SHORT addr, data;
	BYTE ch;
	BYTE FAR * fulladdr;
	addr = expr();
	if( bForceToReturnSuper ) return;
	while( TRUE ) {
		ch = *executionPointer++;
		if( ch != ' ' && ch != '\t' ) break;
	}
	if( ch != ',' ) {
		syntaxError();
		return;
	}
	data = expr();
	if( bForceToReturnSuper ) return;
	fulladdr = (BYTE FAR *)(((DWORD)defseg << 16) + (WORD)addr);
#ifdef WW
	*fulladdr = data;
#else
	printf("poke: %08x %02x\n", fulladdr, data );
#endif
*/
}
//---------------------------------------------------------------------------
void WonbeSt_call()
{
/*
	SHORT addr;
	BYTE FAR * fulladdr;
	addr = expr();
	if( bForceToReturnSuper ) return;
	fulladdr = (BYTE FAR *)(((DWORD)defseg << 16) + (WORD)addr);
#ifdef WW
#ifdef VC15
// VC++1.5̂ƂɎgR[h
	__asm {
		push si
		push di
		push bp
		mov ax,registers[(KEYWORD_AX-KEYWORD_AX)*2]
		mov bx,registers[(KEYWORD_BX-KEYWORD_AX)*2]
		mov cx,registers[(KEYWORD_CX-KEYWORD_AX)*2]
		mov dx,registers[(KEYWORD_DX-KEYWORD_AX)*2]
		mov si,registers[(KEYWORD_SI-KEYWORD_AX)*2]
		mov di,registers[(KEYWORD_DI-KEYWORD_AX)*2]
		mov es,registers[(KEYWORD_ES-KEYWORD_AX)*2]
		push ds
		mov ds,registers[(KEYWORD_DS-KEYWORD_AX)*2]
		call far ptr ss:[fulladdr]
		pop ds
		mov registers[(KEYWORD_AX-KEYWORD_AX)*2],ax
		mov registers[(KEYWORD_BX-KEYWORD_AX)*2],bx
		mov registers[(KEYWORD_CX-KEYWORD_AX)*2],cx
		mov registers[(KEYWORD_DX-KEYWORD_AX)*2],dx
		mov registers[(KEYWORD_SI-KEYWORD_AX)*2],si
		mov registers[(KEYWORD_DI-KEYWORD_AX)*2],di
		mov registers[(KEYWORD_ES-KEYWORD_AX)*2],es
		pop bp
		pop di
		pop si
	}
#else
	// VC++ 1.5ȊȌn̂߂̃R[h͍Ă܂B~lA삵܂傤
#endif
#else
	printf("call: %08x\n", fulladdr );
#endif
*/
}
//---------------------------------------------------------------------------
void WonbeSt_int()
{
/*
	SHORT number;
	number = expr();
	if( bForceToReturnSuper ) return;
#ifdef WW
#ifdef VC15
// VC++1.5̂ƂɎgR[h
	{
		static BYTE specialIntCallCode[3] = { 0xcd, 0x00, 0xcb };
		DWORD specialPtr;
		specialIntCallCode[1] = (BYTE)number;
		specialPtr = (((DWORD)getdseg() << 16) + (WORD)specialIntCallCode);
		__asm {
			push si
			push di
			push bp
			mov ax,registers[(KEYWORD_AX-KEYWORD_AX)*2]
			mov bx,registers[(KEYWORD_BX-KEYWORD_AX)*2]
			mov cx,registers[(KEYWORD_CX-KEYWORD_AX)*2]
			mov dx,registers[(KEYWORD_DX-KEYWORD_AX)*2]
			mov si,registers[(KEYWORD_SI-KEYWORD_AX)*2]
			mov di,registers[(KEYWORD_DI-KEYWORD_AX)*2]
			mov es,registers[(KEYWORD_ES-KEYWORD_AX)*2]
			push ds
			mov ds,registers[(KEYWORD_DS-KEYWORD_AX)*2]
			call far ptr ss:[specialPtr]
			pop ds
			mov registers[(KEYWORD_AX-KEYWORD_AX)*2],ax
			mov registers[(KEYWORD_BX-KEYWORD_AX)*2],bx
			mov registers[(KEYWORD_CX-KEYWORD_AX)*2],cx
			mov registers[(KEYWORD_DX-KEYWORD_AX)*2],dx
			mov registers[(KEYWORD_SI-KEYWORD_AX)*2],si
			mov registers[(KEYWORD_DI-KEYWORD_AX)*2],di
			mov registers[(KEYWORD_ES-KEYWORD_AX)*2],es
			pop bp
			pop di
			pop si
		}
	}
#else
	// VC++ 1.5ȊȌn̂߂̃R[h͍Ă܂B~lA삵܂傤
#endif
#else
	printf("int: %04x\n", number );
#endif
*/
}
//---------------------------------------------------------------------------
void WonbeSt_tron()
{
//	traceFlag = TRUE;
}
//---------------------------------------------------------------------------
void WonbeSt_troff()
{
//	traceFlag = FALSE;
}
//---------------------------------------------------------------------------
void WonbeSt_colormode()
{
/*
	SHORT newmode;
	newmode = expr();
	if( bForceToReturnSuper ) return;
#ifdef WW
	if( isWonderSwanColor() ) {
		//SHORT result;
		//result = wwc_set_color_mode( newmode );
		//if( result != newmode ) {
		//paramError();	//l̐ݒɎsƂ
		//return;
		//}
	}
#else
	printf("colormode: %d\n", newmode );
#endif
*/
}
//---------------------------------------------------------------------------
void WonbeSt_palette()
{
/*
	SHORT index, r, g, b;
	BYTE ch;
	index = expr();
	if( bForceToReturnSuper ) return;
	while( TRUE ) {
		ch = *executionPointer++;
		if( ch != ' ' && ch != '\t' ) break;
	}
	if( ch != ',' ) {
		syntaxError();
		return;
	}
	r = expr();
	if( bForceToReturnSuper ) return;

	while( TRUE ) {
		ch = *executionPointer++;
		if( ch != ' ' && ch != '\t' ) break;
	}
	if( ch != ',' ) {
		syntaxError();
		return;
	}
	g = expr();
	if( bForceToReturnSuper ) return;

	while( TRUE ) {
		ch = *executionPointer++;
		if( ch != ' ' && ch != '\t' ) break;
	}
	if( ch != ',' ) {
		syntaxError();
		return;
	}
	b = expr();
	if( bForceToReturnSuper ) return;

#ifdef WW
	if( isWonderSwanColor() ) {
		wwc_palette_set_color(0, index, ((r << 8)&0xf00) | ((g << 4)&0xf0) | (b&0xf)  );
	}
#else
	printf("palette: %d (%d,%d,%d)\n", index, r, g, b );
#endif
*/
}
//---------------------------------------------------------------------------
void WonbeSt_color()
{
/*
	SHORT fore, back;
	BYTE ch;
	fore = expr();
	if( bForceToReturnSuper ) return;
	while( TRUE ) {
		ch = *executionPointer++;
		if( ch != ' ' && ch != '\t' ) break;
	}
	if( ch != ',' ) {
		syntaxError();
		return;
	}
	back = expr();
	if( bForceToReturnSuper ) return;
#ifdef WW
	font_set_color( (fore & 0x03) | ((back << 2) & 0x0c));
#else
	printf("color: %d %d\n", fore & 3, back & 3 );
#endif
*/
}
//---------------------------------------------------------------------------
void WonbePtextLocate(s16 argX, s16 argY)
{
	s16 x = argX;
	s16 y = argY;

	if(x <               0) x = 0;
	if(x >= SCREEN_TEXT_CX) x = SCREEN_TEXT_CX-1;
	if(y <               0) y = 0;
	if(y >= SCREEN_TEXT_CY) y = SCREEN_TEXT_CY-1;

	ScreenText.x  = x;
	ScreenText.y  = y;
	ScreenText.wy = y;
}
//---------------------------------------------------------------------------
//sԍ
u8* WonbeGetLineReferenceFromLineNumber(s16 lineNumber)
{
	ST_WONBE* w = &Wonbe;
	u8* p;
	u16 t;

	p = w->Code;

	for(;;)
	{
		t = *p | (*(p+1) << 8);

		if(t == 0)
		{
			return p;
		}

		if(lineNumber == t)
		{
			return p;
		}

		p += *(p+2) | (*(p+3) << 8);
	}
}
//---------------------------------------------------------------------------
u8* WonbeGetInsertionPointFromLineNumber(u16 lineNumber)
{
	ST_WONBE* w = &Wonbe;
	u8* p;
	u16 t;

	p = w->Code;

	for(;;)
	{
		t = *p | (*(p+1) << 8);

		if(t == 0)
		{
			return p;
		}
		if(lineNumber <= t)
		{
			return p;
		}

		p += *(p+2) | (*(p+3) << 8);
	}
}
//---------------------------------------------------------------------------
void WonbeSyntaxError()
{
	DrawErrorText((u8*)"Err: Syntax Error in %d.", Wonbe.ReadLineCnt);
	State   = STATE_ERROR;
}
//---------------------------------------------------------------------------
void WonbeDivideByZero()
{
	DrawErrorText((u8*)"Err: Divide by 0 in %d.", Wonbe.ReadLineCnt);
	State   = STATE_ERROR;
}
//---------------------------------------------------------------------------
void WonbeReadLineOverflow()
{
	DrawErrorText((u8*)"Err: ReadLine Overflow in %d", Wonbe.ReadLineCnt);
	State   = STATE_ERROR;
}
//---------------------------------------------------------------------------
void WonbeOutOfMemory()
{
	DrawErrorText((u8*)"Err: Out of memory in %d", Wonbe.ReadLineCnt);
	State   = STATE_ERROR;
}
//---------------------------------------------------------------------------
void WonbeOutOfArraySubscription()
{
	DrawErrorText((u8*)"Err: Out of Array Subscription in %d", Wonbe.ReadLineCnt);
	State   = STATE_ERROR;
}
//---------------------------------------------------------------------------
void WonbeLineNumberZeroError()
{
	DrawErrorText((u8*)"Err: Invalid Line Number in %d", Wonbe.ReadLineCnt);
	State   = STATE_ERROR;
}
//---------------------------------------------------------------------------
void WonbeLineNumberNotFound(u16 lineNumber)
{
	DrawErrorText((u8*)"Err: Line Number %d not Found in %d", lineNumber);
	State   = STATE_ERROR;
}
//---------------------------------------------------------------------------
void WonbeNextWithoutFor()
{
	DrawErrorText((u8*)"Next without For in %d", Wonbe.ReadLineCnt);
	State   = STATE_ERROR;
}
//---------------------------------------------------------------------------
void WonbeStackOverflow()
{
	DrawErrorText((u8*)"Stack Overflow in %d", Wonbe.ReadLineCnt);
	State   = STATE_ERROR;
}
//---------------------------------------------------------------------------
void WonbeParamError()
{
	DrawErrorText((u8*)"Parameter Error in %d", Wonbe.ReadLineCnt);
	State   = STATE_ERROR;
}
//---------------------------------------------------------------------------
void DrawErrorText(u8* str, u16 lineCnt)
{
	char msg[64];
	bprintf(msg, (char*)str, lineCnt);
	DrawScreenText((u8*)msg);
}
//---------------------------------------------------------------------------
bool WonbeIsLetter(u8 chr)
{
	return (chr >= 'a' && chr <= 'z') || (chr >= 'A' && chr <= 'Z') ? TRUE : FALSE;
}
//---------------------------------------------------------------------------
bool WonbeIsNumber(u8 chr)
{
	return (chr >= '0' && chr <= '9') ? TRUE : FALSE;
}
//---------------------------------------------------------------------------
void DebugConvertCode()
{
	ST_WONBE* p = &Wonbe;
	u8* src     = p->ConvertLine;

	dprintf("\nDebugConvertCode \n");
	while(*src != EOL)
	{
		dprintf("%x: %x \n", src, *src);
		src++;
	}
	dprintf("\n");
}
//---------------------------------------------------------------------------
void DebugCode()
{
	ST_WONBE* p = &Wonbe;
	u8* src     = p->Code;

	dprintf("\nDebugCode \n");
	s16 i;
	for(i=0; i<p->DataTop; i++)
	{
		dprintf("%x: %x \n", src, *src);
		src++;
	}
	dprintf("\n");
}
